# JuliaDockerClient
<div style="display: flex; align-items: center;">
  <div style="flex: 1; padding-right: 10px;">
    A Julia package to communicate with Docker (or Podman) daemons through the unix socket and according to the 
    <a href="https://docs.docker.com/engine/api/v1.40">Docker Remote API v1.40</a>. It offers the possibility 
    to access multiple registries and to manage both images and containers.
  </div>
  <div>
    <img src="logo.png" alt="logo" width="100" />
  </div>
</div>

---

[![GitLab License](https://img.shields.io/gitlab/license/fact%2Futils%2FJuliaDockerClient.jl?gitlab_url=https%3A%2F%2Fgit.nilu.no&style=flat&color=orange)](https://www.gnu.org/licenses/agpl-3.0.en.html#license-text)
[![DOI](https://img.shields.io/badge/DOI-10.17605%2FOSF.IO%2FJWQYT-blue?style=flat)](https://doi.org/10.17605/OSF.IO/JWQYT)

---

## Use
1. To install the package in your project from our [Local Registry](https://git.nilu.no/julia/registry):
```julia
using Pkg
Pkg.Registry.add(url="https://git.nilu.no/julia/registry")
Pkg.add("JuliaDockerClient")
```
2. To use the package:
```julia
using JuliaDockerClient
``````
Please refer to the package documentation for details on how to access Docker API: https://fact.pages.nilu.no/utils/JuliaDockerClient.jl/


---
## Specifications
The software implements version 1.40 fo Docker APIs to preserve full compatibility with both Docker and Podman daemons. https://docs.docker.com/engine/api/v1.40

---
## Notes

---
## Author
Riccardo Boero - ribo@nilu.no

## License
[![AGPL v3](https://www.gnu.org/graphics/agplv3-88x31.png "License Icon")](https://www.gnu.org/licenses/agpl-3.0.en.html#license-text)

## Citation

- Boero, Riccardo. 2024. “FACT Utils: Julia Docker Client.” OSF. [doi:10.17605/OSF.IO/JWQYT](https://doi.org/10.17605/OSF.IO/JWQYT). 

Part of the Fine scAle eConomic daTa - FACT project:
- Boero, Riccardo. 2024. “Fine scAle eConomic daTa - FACT.” OSF. [doi:10.17605/OSF.IO/PV4ZW](https://doi.org/10.17605/OSF.IO/PV4ZW). 

