using Test
using JuliaDockerClient

@testset "Docker Client Utils Tests" begin

    @testset "test_connection Tests" begin
        # Testing if the Docker service is reachable
        @test test_connection() == true  # This expects the Docker service to be running
    end

    @testset "registry_login Tests" begin
        @testset "registry_login Tests" begin
            # Access environment variables using ENV dictionary
            registry_url = ENV["REGISTRY_URL"]
            registry_username = ENV["REGISTRY_USERNAME"]
            registry_pass = ENV["REGISTRY_PASS"]

            # Testing with environment-provided data
            encoded_auth = registry_login(registry_url, registry_username, registry_pass)

            # Check if the return value is a valid base64-encoded string
            @test typeof(encoded_auth) == String && !isempty(encoded_auth)
        end
    end

end

@testset "Docker Client Images and Containers Tests" begin

    @testset "list_images Tests" begin
        images = list_images()
        @test typeof(images) == Vector{Any}
        
        if !isempty(images)
            @test typeof(images[1]) == Dict{String,Any}
            @test haskey(images[1], "Id")  # Example test for a key in the JSON object
        end
    end

    @testset "list_containers Tests" begin
        containers = list_containers()
        @test typeof(containers) == Vector{Any}

        if !isempty(containers)
            @test typeof(containers[1]) == Dict{String,Any}
            @test haskey(containers[1], "Id")  # Example test for a key in the JSON object
        end
    end

end
